version: '3'

services:
  traefik:
    image: {{ traefik_image }}:{{ traefik_ver }}
    container_name: {{ traefik_container_name }}
    restart: unless-stopped
    security_opt:
      - no-new-privileges:true
    networks:
      - {{ traefik_network }}
    ports:
      - 80:80
      - 443:443
      - {{ traefik_monitor_port }}:{{ traefik_monitor_port }}
    environment:
      - CF_DNS_API_TOKEN=${CF_DNS_API_TOKEN}
      - CF_ZONE_API_TOKEN=${CF_ZONE_API_TOKEN}
    volumes:
      - /etc/localtime:/etc/localtime:ro
      - /var/run/docker.sock:/var/run/docker.sock:ro
      - {{ traefik_home }}/data/traefik.yml:/traefik.yml:ro
      - {{ traefik_home }}/data/acme:/etc/traefik/acme
{% if hosts_to_proxy is defined %}
      - {{ traefik_home }}/data/config.yml:/config.yml:ro
{% endif %}
    labels:
      - "traefik.enable=true"
{% if traefik_api_dashboard == "true" %}
      - "traefik.http.routers.{{ traefik_container_name }}.entrypoints=http"
      - "traefik.http.routers.{{ traefik_container_name }}.rule=Host(`{{ traefik_container_name }}.{{ traefik_zone }}`)"
      # echo $(htpasswd -nb user password) | sed -e s/\\$/\\$\\$/g
      - "traefik.http.middlewares.{{ traefik_container_name }}-auth.basicauth.users={{ traefik_api_dashboard_basic_auth }}"
      - "traefik.http.middlewares.{{ traefik_container_name }}-https-redirect.redirectscheme.scheme=https"
      - "traefik.http.middlewares.sslheader.headers.customrequestheaders.X-Forwarded-Proto=https"
      - "traefik.http.routers.{{ traefik_container_name }}.middlewares={{ traefik_container_name }}-https-redirect"
      - "traefik.http.routers.{{ traefik_container_name }}-secure.entrypoints=https"
      - "traefik.http.routers.{{ traefik_container_name }}-secure.rule=Host(`{{ traefik_container_name }}.{{ traefik_zone }}`)"
      - "traefik.http.routers.{{ traefik_container_name }}-secure.middlewares={{ traefik_container_name }}-auth"
{% endif %}
      - "traefik.http.routers.{{ traefik_container_name }}-secure.tls=true"
      - "traefik.http.routers.{{ traefik_container_name }}-secure.tls.certresolver=cloudflare"
      - "traefik.http.routers.{{ traefik_container_name }}-secure.tls.domains[0].main={{ traefik_zone }}"
      - "traefik.http.routers.{{ traefik_container_name }}-secure.tls.domains[0].sans=*.{{ traefik_zone }}"
      - "traefik.http.routers.{{ traefik_container_name }}-secure.service=api@internal"

networks:
  {{ traefik_network }}:
    name: {{ traefik_network }}
{% if traefik_ipv6 %}
    enable_ipv6: true
    ipam:
      config:
        - subnet: {{ traefik_ipv6_subnet }}
{% endif %}
